// code by jph

#ifndef MATH_INCLUDED
#define MATH_INCLUDED

#define MATH_E        2.71828182845904523536
#define MATH_LOG2E    1.44269504088896340736
#define MATH_LOG10E   0.434294481903251827651
#define MATH_LN2      0.693147180559945309417
#define MATH_LN10     2.30258509299404568402
#define MATH_PI       3.14159265358979323846
#define MATH_2PI      6.2831853071795864769
#define MATH_PI_2     1.57079632679489661923
#define MATH_PI_3     1.047197551196597746154
#define MATH_PI_4     0.785398163397448309616
#define MATH_1_PI     0.318309886183790671538
#define MATH_2_PI     0.636619772367581343076
#define MATH_2_SQRTPI 1.12837916709551257390
#define MATH_1_3      0.333333333333333333332
#define MATH_SQRT2    1.41421356237309504880
#define MATH_SQRT1_2  0.707106781186547524401
#define MATH_DEG2RAD  0.01745329251994329576923

class math {
  public:    
  
    static bool Abs(const bool& a) {
      return a ? 1 : 0;
    }

    template<class type>
    static type Abs(const type& a) {
      return a<0 ? -a : a;
    }
    
    //template<class type>
    //static int Epsilon(type a,double b) {
    //  return 0;
    //}
    //
    //static int Epsilon(double a,double b) {          
    //  return Abs(a)<b;
    //}
    
    template<class type>
    static type Sign(const type& a) {
      return 0<=a ? 1 : -1;
    }
    
    //template<class type>
    //static type Sign_tol(const type& num,const type& tol) {
    //  if (num+tol<0)
    //    return -1;
    //  if (0<num-tol)
    //    return  1;
    //  else
    //    return  0;
    //}
    
    template<class type>
    static type Sign(const type& a,const type& b) {
      return 0<=b ? (0<=a ? a : -a) : (0<=a ? -a : a);
    }
    
    template<class type>
    static type Clip(type min_,type num,type max_) { // ensures number is within bounds
      return min(max(min_,num),max_);
    }
    
};

#endif
